# A description of what this class does
#
# @summary A short summary of the purpose of this class
#
# @example
#   include workstation::asdf::packages
class workstation::asdf::packages (
  String[1] $user = $workstation::user,
  String[1] $home = $workstation::home,
  Integer $timeout = $workstation::asdf::timeout,
  Optional[Hash[String[1], Array[String[1]]]] $packages = $workstation::asdf::packages,
) {

  if $packages {
    $packages.each |String $pkg, Array[String[1]] $versions| {
      exec { "${home}/.asdf/bin/asdf plugin-add ${pkg}":
        user        => $user,
        environment => ["HOME=${home}"],
        unless      => "${home}/.asdf/bin/asdf plugin-update ${pkg}",
      }

      $versions.each |String $v|{
        exec { "${home}/.asdf/bin/asdf install ${pkg} ${v}":
          user        => $user,
          environment => ["HOME=${home}"],
          timeout     => $timeout,
          unless      => "${home}/.asdf/bin/asdf list ${pkg} | awk \'{\$1=\$1};1\' | grep -Fx ${v}",
          require     => Exec["${home}/.asdf/bin/asdf plugin-add ${pkg}"],
        }
      }
    }
  } else {
    notice('No asdf installs provided.')
  }

}
