# A description of what this class does
#
# @summary A short summary of the purpose of this class
#
# @example
#   include workstation
class workstation (
  String[1] $user = $facts['primary_user'],
  Enum['bash', 'zsh', 'fish'] $shell = 'bash',
  Optional[String[1]] $github_token = undef,
  Optional[Array[Hash]] $dotfiles = undef,
) {

  if $user == 'root' {
    fail('Workstation module user cannot be root!')
  }

  $home = $facts['os']['family'] ? {
    'Darwin'  => "/Users/${user}",
    'Linux' => "/home/${user}",
  }

  include workstation::user
  include workstation::asdf
  include workstation::dotfiles

  if $facts['os']['family'] == 'Darwin' {
    class {'workstation::mac':
      require => Class['workstation::user'],
      before  => Class['workstation::dotfiles'],
    }
  } elsif $facts['os']['family'] == 'Linux' {
    notice('There are no Linux-only classes at this time.')
  } else {
    fail("Unsupported platform: ${facts['os']['family']}")
  }

Class['workstation::user']
-> Class['workstation::asdf']

}
