# A description of what this class does
#
# @summary A short summary of the purpose of this class
#
# @example
#   include workstation::user
class workstation::user (
  String[1] $user = $workstation::user,
  String[1] $home = $workstation::home,
  Enum['bash', 'zsh', 'fish'] $shell = $workstation::shell,
) {

  $shell_path = $shell ? {
    'bash' => '/bin/bash',
    'zsh'  => '/bin/zsh',
    'fish' => '/usr/local/bin/fish',
  }

  user { $workstation::user:
    shell => $shell_path,
    home  => $home,
  }

  if $shell == 'bash' {
      $bash_config = $facts['os']['family'] ? {
        'Darwin' => "${home}/.bash_profile",
        'Linux'  => "${home}/.bashrc",
      }

      file { $bash_config:
        ensure => file,
        owner  => $user,
      }
  }

}
